https://codeforces.com/contest/510/problem/D
思路:
其实可以变成是否可以取一些数,其方程组可以得到t=1,因为1才能到任意距离嘛。因此裴蜀定理就可以知道是其取的数要gcd=1。
由此变成取一定数使得其gcd=1的代价最小。
dp[i]:其gcd为i的时候的最小代价。
由于倒推有一点麻烦。改成顺推,由可以更新的下一状态为dp[ gcd(a[i],j)] 其中这个j是之前出现了的gcd值,dp[gcd(a[i],j)]=min(dp[gcd(a[i],j) , dp[j]+c[i] (本次更新) ]
由于gcd可以很大,直接开数组会炸。因此可以离散化。
细节注意数值会出现重复的,所以开始初始化一个数的gcd的时候最后要更新成最小。
#include<iostream>
#include<vector>
#include<queue>
#include<cstring>
#include<cmath>
#include<map>
#include<set>
#include<cstdio>
#include<algorithm>
#define debug(a) cout<<#a<<"="<<a<<endl;
using namespace std;
const int maxn=310;
typedef long long LL;
inline LL read(){LL x=0,f=1;char ch=getchar(); while (!isdigit(ch)){if (ch=='-') f=-1;ch=getchar();}while (isdigit(ch)){x=x*10+ch-48;ch=getchar();}
return x*f;}
map<LL,LL>dp;
LL a[maxn],c[maxn];
int main(void){
cin.tie(0);std::ios::sync_with_stdio(false);
LL n;cin>>n;
for(LL i=1;i<=n;i++) cin>>a[i];
for(LL i=1;i<=n;i++) cin>>c[i];
for(LL i=1;i<=n;i++){
///dp[a[i]]=c[i];注意重复
if(!dp.count(a[i])) dp[a[i]]=c[i];
else dp[a[i]]=min(dp[a[i]],c[i]);
}
for(LL i=1;i<=n;i++){
for(auto j:dp){
LL g=__gcd(j.first,a[i]);
if(!dp.count(g)) dp[g]=dp[j.first]+c[i];
else dp[g]=min(dp[g],dp[j.first]+c[i]);
}
}
if(!dp[1]) cout<<"-1"<<"\n";
else cout<<dp[1]<<"\n";
return 0;
}